; welcome to the mrdead module, the mred emulator -- (c) Corey Sweeney, 2005

#| Changelog:
  * 04/06/2005 Changed some classes into interfaces and abstract classes -- Daniel
  * 04/06/2005 Split this module into this and mrdead-mixins after changing all the classes into mixins -- Daniel
|#

(module mrdead mzscheme
  (provide frame%
           button%
           horizontal-panel%
           vertical-panel%
           message%
           text-field%)

  (require (lib "class.ss")
           "mrdead-mixins.ss"
           "../gtk.ss"
           "../gobject.ss")
  

  ;; run, GTK, run.
  (thread gtk-run)

  ;; Compose all the mixins into classes.
  
  (define gtk-object% (gtk-object-mixin object%))
  
  (define area% (area-mixin gtk-object%))
  (define window% (window-mixin area%))
  
  (define subwindow%
    (subwindow-mixin
       (subarea-mixin window%)))

  (define area-container-window%
     (area-container-window-mixin
      (area-container-mixin window%)))
  
  (define panel%
    (panel-mixin
     (subwindow-mixin
      (subarea-mixin area-container-window%))))

  (define control% (control-mixin subwindow%))

  (define frame% (top-level-window-mixin area-container-window%))

  (define button% (button-mixin control%))
  
  (define message% (message-mixin control%))
       
  (define horizontal-panel% (horizontal-panel-mixin panel%))
  (define vertical-panel% (vertical-panel-mixin panel%))

  
;  (define gtk-primative-entry% (gtk-primative-entry-mixin control%))  
;  
; 
  (define text-field% 
    (class (horizontal-panel-mixin 
;         (class (message-mixin 
                 ;gtk-primative-entry%)
                 message%)
;                                  (super-new [parent parent])))
      (super-new [parent this])))
  
  
    ;;we want to be a horizontal-panel%, but inherit (init-field value) from gtk-primative-entry% and (init-field label) from message%, then of course we need to add message to horizontal-panel, and then gtk-primative-entry to horizontal-panel.
    

  
;  (define text-field% 
;    (class (gtk-primative-entry-mixin (message-mixin horizontal-panel%))
;      ;;we want to be a horizontal-panel%, but inherit (init-field value) from gtk-primative-entry% and (init-field label) from message%
;      
;;      (init-field (label "message"))
;;      (init-field (value "text"))
;
;      (super-new)
;      
;;      (new
;;       message%
;;       (parent this)
;;       (style '())
;;       (stretchable-width #f)
;;       (stretchable-height #f)
;;       (label label))
;;             
;;      (new
;;       gtk-primative-entry%
;;       (parent this)
;;       (style '())
;;       (stretchable-width #f)
;;       (stretchable-height #f)
;;       (label label))
;      
;      
;      (inherit show)
;      (show #t)))
)