(module mrdead-interfaces mzscheme
  (require (lib "class.ss"))
  (provide (all-defined))
  
  #| Note -- it would be nice to be able to write this down:
    (provide/contract
      [window<%> (interface-contract [show (boolean? . -> . void?)])])
  |#

  (define gtk-object<%>
    (interface () get-real-gtk-object set-real-gtk-object!))

  ;; TODO: this interface should come from the MrEd library
  (define area<%>
    (interface (gtk-object<%>) get-parent))
  
  ;; TODO: this interface should come from the MrEd library
  (define window<%>
    (interface (area<%>) show))

  ;; TODO: this interface should come from the MrEd library
  (define area-container<%>
    (interface (area<%>) add-child))
  
  (define area-container-window<%>
    (interface (area-container<%> window<%>)))

  (define subarea<%>
    (interface (area<%>)))
  
  ;; TODO: this interface should come from the MrEd library
  (define top-level-window<%>
    (interface (area-container-window<%>) on-close))
  
  ;; TODO: this interface should come from the MrEd library
  (define subwindow<%>
    (interface (subarea<%> window<%>)))
  
  (define panel<%>
    (interface (area-container-window<%> subwindow<%>)))
  
  (define horizontal-panel<%>
    (interface (panel<%>)))

  (define vertical-panel<%>
    (interface (panel<%>)))
  
  (define control<%>
    (interface (subwindow<%>)))
  
  (define button<%>
    (interface (control<%>)))
  
  (define message<%>
    (interface (control<%>) get-label set-label))

  (define gtk-primative-entry<%>
    (interface (control<%>) get-value set-value))
  )